(function( $ ){

///////////////////////////////////////////
// variable will be used by all ui-widgets
//////////////////////////////////////////
window._nokia_webapp_widegtWidth = window.innerWidth-12;	// 12px = 10px (5px margin LEFT-RIGHT) + 2px (1px border LEFT-RIGHT)				


  var methods = {
	
	feed : function(options){
		//var options = $.extend($.fn.s40rss.defaults, options);
		
		jQuery.getFeed({
			url: options.url,
			success: function processRSS(feed, data){
				//$.fn.s40rss.defaults.xml = feed;
				if (jQuery.isFunction(options.success)) 
					options.success({'error': 0, 'status': 200, 'message': 'Feed data loaded success', 'data' : feed});
			},
			error: function(jqXHR, textStatus) {
				$.fn.s40rss.defaults.xml = null;
				var data;
				if(this.status === 204)
					data = {'error': 1, 'status': 204, 'message': 'No items in the specified url'};
				else if(this.status === 500)
					data = {'error': 1, 'status': 500, 'message': 'Not a feed url'};
				else
					data = {'error': 1, 'status': textStatus, 'message': 'Some problem in fetching the feed'};
					
				if (jQuery.isFunction(options.error)) 
					options.error(data);

			}
		});
	},
	
	render : function(options){
		var options = $.extend($.fn.s40rss.defaults, options);
		
		if(typeof options.xml.items === 'undefined'){
			return "No feed items to render!";
		}

		// slice the feed items based on user-limit request: default-limit is 5
		if(options.xml.items.length > 0 && (options.xml.items.length > options.limit) ){
			options.xml.items = options.xml.items.splice(0, options.limit);
		}
		
		// read the template-content
		var template = Handlebars.compile(options.template)

		// loop through the items to render with template
		var rendered_output = "";
		$.each(options.xml.items, function(key, value) {
			rendered_output += template(value);
		});
		return rendered_output;
	},
	
	website : function(options){
		var options = $.extend($.fn.s40rss.defaults, options);
		
		jQuery.getFeed({
			url: options.url,
			success: function processRSS(feed, data){
				$.fn.s40rss.defaults.xml = feed;
				if (jQuery.isFunction(options.success)) 
					options.success({'error': 0, 'status': 200, 'message': 'Finding the feed success'});
			},
			error: function(jqXHR, textStatus) {
				$.fn.s40rss.defaults.xml = null;
				var data;
				if(this.status === 204)
					data = {'error': 1, 'status': 204, 'message': 'No feeds found on the site'};
				else
					data = {'error': 1, 'status': textStatus, 'message': 'Some problem in fetching the feed'};
					
				if (jQuery.isFunction(options.error)) 
					options.error(data);

			}
		});
	},
	
	rss : function(options){
		var options = $.extend($.fn.s40rss.defaults, options);
		var callee = this;
		$(callee).html('<p class="widget-loading-status">Loading...</p>');
		$(callee).s40rss('feed', {
		  url: options.url,
		  success: function(html){
			// update with the feed content
			$(callee).html($(options.div).s40rss('render', {
				limit: options.limit,
				template: options.template
			}));
		  },
		  error: function(){
			// show the error notification
			$(callee).html('<p class="widget-loading-error">Failed load content</p>');
		  }
		});
	},
	
	clip: function(options){				
		// create a proxy url
		var url = options.url + " " + options.clip_id;
		url = 'http://tools.nokia.com/nwt/proxy.php?url='+url;
		
		// load the clipped content
		$(options.div).load(url, function(response, status, xhr){
			
			////////////////////////////////////////////////////////////
			//
			//	using URI.js to reslove the relative URL's
			//	read more about this at http://code.google.com/p/js-uri/
			//
			////////////////////////////////////////////////////////////
			var baseURI = new URI(options.url);
			var anchorURI;
			var anchorURI_new;

			$(options.div).find("a").each(function(){
				var thisAnchor = this;
				var href = $(thisAnchor).attr("href");			

				if(href.indexOf("http") == -1 && href.indexOf("javascript:") == -1 &&  href.indexOf("void(0)") == -1){
					anchorURI = new URI(href);
					anchorURI_new = anchorURI.resolve(baseURI)
					newHref = anchorURI_new.toString();
					$(thisAnchor).attr("href", newHref);
				}
				
				if(href.indexOf("javascript:") != -1 ||  href.indexOf("void(0)") != -1){
					$(thisAnchor).css("display","none");
				}
				
				$(thisAnchor).attr("target","_blank");
			});

			if (status == "error") {
				$(options.div).html("Sorry but there was an error: " + xhr.status + " " + xhr.statusText);
			}

		});
	},

	refresh: function(){
		// don't remove
	}	
  };

  $.fn.s40rss = function( method ) {
	if ( methods[method] ) {
	  return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
	} else if ( typeof method === 'object' || ! method ) {
	  return methods.init.apply( this, arguments );
	} else {
	  $.error( 'Method ' +  method + ' does not exist on jQuery.tooltip' );
	}    
  
  };
  
  $.fn.s40rss.defaults = {
		url: '',
		limit: 5,
		xml: null,
		template: 'rss-list-with-image-template'
	};

})( jQuery );